/*
 * CharacterFactory.cpp
 *
 *  Created on: 09/giu/2014
 *      Author: bertini
 */

#include "CharacterFactory.h"

#include "Wizard.h"
#include "MageKnight.h"
#include "Knight.h"
#include "MeleeWeapon.h"
#include "MissileWeapon.h"

Character* CharacterFactory::makeWizard(std::string name, int hp, int l,
		int a) {
	Wizard* result = new Wizard(name, hp, l, a);
	return result;
}

Character* CharacterFactory::makeKnight(std::string name, int hp, int l, int d, int w,
		CharacterFactory::KnightType type) {
	Weapon* sword = new MeleeWeapon(w);
	Character* result;
	switch (type) {
	case CharacterFactory::StandardKnightT:
		result = new Knight(name, hp, l, d);
		break;
	case CharacterFactory::MageKnightT:
		result = new MageKnight(name, hp, l, d);
		break;
	default:
		result = new Knight(name, hp, l, d);
		break;
	}
	result->setWeapon(sword);
	return result;
}
