/*
 * Wizard.cpp
 *
 *  Created on: 07/apr/2014
 *      Author: bertini
 */

#include "Wizard.h"
#include <iostream>

Wizard::Wizard(std::string aName, int hp, int l, int a, int x, int y) :
Character(hp, l, a, x, y) {
	name = aName;
	std::cout << "Wizard -  constructor" << std::endl;
}

Wizard::~Wizard() {
	std::cout << "Delete Wizard from game map" << std::endl;
}

int Wizard::fight(Character& enemy) {
	Dice aDice(4);
	int damage = 0;
	int hit = aDice.throwDice();

	if (hit > enemy.getLevel()) {
		if (!weapon)
			return 1; // bare hand fight: mimimum damage

		damage = weapon->useWeapon();
		if (damage > enemy.getArmor()) {
			enemy.setHp(enemy.getHp() - damage);
			std::cout << "enemy hit: " << damage << std::endl;
		} else {
			std::cout << "did not pass through enemy armor !" << std::endl;
		}
	} else
		std::cout << "hit miss !" << std::endl;

	return damage;
}

int Wizard::doMagic(Character& player) {
	Dice aDice(12);
	int damage = aDice.throwDice() * level;
	player.setHp(player.getHp() - damage);
	std::cout << "Magic attack - " << name << " enemy hit: " << damage << std::endl;
	return damage;
}

void Wizard::move(int x, int y) {
	posX = x;
	posY = y;
	std::cout << "Wizard moving to: " << x << " - " << y << std::endl;
}
